# wxCommandEvent Class Reference
[Events]

`#include <wx/event.h>`

Inheritance diagram for wxCommandEvent:
[legend]

## Detailed Description

This event class contains information about command events, which originate from a variety of simple controls.

Note that wxCommandEvents and wxCommandEvent-derived event classes by default and unlike other wxEvent-derived classes propagate upward from the source window (the window which emits the event) up to the first parent which processes the event. Be sure to read How Events Propagate Upwards.

More complex controls, such as wxTreeCtrl, have separate command event classes.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxCommandEvent& event)
Event macros:

- EVT_COMMAND(id, event, func):
  Process a command, supplying the window identifier, command event identifier, and member function.
- EVT_COMMAND_RANGE(id1, id2, event, func):
  Process a command for a range of window identifiers, supplying the minimum and maximum window identifiers, command event identifier, and member function.
- EVT_BUTTON(id, func):
  Process a `wxEVT_COMMAND_BUTTON_CLICKED` command, which is generated by a wxButton control.
- EVT_CHECKBOX(id, func):
  Process a `wxEVT_COMMAND_CHECKBOX_CLICKED` command, which is generated by a wxCheckBox control.
- EVT_CHOICE(id, func):
  Process a `wxEVT_COMMAND_CHOICE_SELECTED` command, which is generated by a wxChoice control.
- EVT_COMBOBOX(id, func):
  Process a `wxEVT_COMMAND_COMBOBOX_SELECTED` command, which is generated by a wxComboBox control.
- EVT_LISTBOX(id, func):
  Process a `wxEVT_COMMAND_LISTBOX_SELECTED` command, which is generated by a wxListBox control.
- EVT_LISTBOX_DCLICK(id, func):
  Process a `wxEVT_COMMAND_LISTBOX_DOUBLECLICKED` command, which is generated by a wxListBox control.
- EVT_CHECKLISTBOX(id, func):
  Process a `wxEVT_COMMAND_CHECKLISTBOX_TOGGLED` command, which is generated by a wxCheckListBox control.
- EVT_MENU(id, func):
  Process a `wxEVT_COMMAND_MENU_SELECTED` command, which is generated by a menu item.
- EVT_MENU_RANGE(id1, id2, func):
  Process a `wxEVT_COMMAND_MENU_RANGE` command, which is generated by a range of menu items.
- EVT_CONTEXT_MENU(func):
  Process the event generated when the user has requested a popup menu to appear by pressing a special keyboard key (under Windows) or by right clicking the mouse.
- EVT_RADIOBOX(id, func):
  Process a `wxEVT_COMMAND_RADIOBOX_SELECTED` command, which is generated by a wxRadioBox control.
- EVT_RADIOBUTTON(id, func):
  Process a `wxEVT_COMMAND_RADIOBUTTON_SELECTED` command, which is generated by a wxRadioButton control.
- EVT_SCROLLBAR(id, func):
  Process a `wxEVT_COMMAND_SCROLLBAR_UPDATED` command, which is generated by a wxScrollBar control. This is provided for compatibility only; more specific scrollbar event macros should be used instead (see wxScrollEvent).
- EVT_SLIDER(id, func):
  Process a `wxEVT_COMMAND_SLIDER_UPDATED` command, which is generated by a wxSlider control.
- EVT_TEXT(id, func):
  Process a `wxEVT_COMMAND_TEXT_UPDATED` command, which is generated by a wxTextCtrl control.
- EVT_TEXT_ENTER(id, func):
  Process a `wxEVT_COMMAND_TEXT_ENTER` command, which is generated by a wxTextCtrl control. Note that you must use wxTE_PROCESS_ENTER flag when creating the control if you want it to generate such events.
- EVT_TEXT_MAXLEN(id, func):
  Process a `wxEVT_COMMAND_TEXT_MAXLEN` command, which is generated by a wxTextCtrl control when the user tries to enter more characters into it than the limit previously set with SetMaxLength().
- EVT_TOGGLEBUTTON(id, func):
  Process a `wxEVT_COMMAND_TOGGLEBUTTON_CLICKED` event.
- EVT_TOOL(id, func):
  Process a `wxEVT_COMMAND_TOOL_CLICKED` event (a synonym for `wxEVT_COMMAND_MENU_SELECTED`). Pass the id of the tool.
- EVT_TOOL_RANGE(id1, id2, func):
  Process a `wxEVT_COMMAND_TOOL_CLICKED` event for a range of identifiers. Pass the ids of the tools.
- EVT_TOOL_RCLICKED(id, func):
  Process a `wxEVT_COMMAND_TOOL_RCLICKED` event. Pass the id of the tool. (Not available on wxOSX.)
- EVT_TOOL_RCLICKED_RANGE(id1, id2, func):
  Process a `wxEVT_COMMAND_TOOL_RCLICKED` event for a range of ids. Pass the ids of the tools. (Not available on wxOSX.)
- EVT_TOOL_ENTER(id, func):
  Process a `wxEVT_COMMAND_TOOL_ENTER` event. Pass the id of the toolbar itself. The value of wxCommandEvent::GetSelection() is the tool id, or -1 if the mouse cursor has moved off a tool. (Not available on wxOSX.)
- EVT_COMMAND_LEFT_CLICK(id, func):
  Process a `wxEVT_COMMAND_LEFT_CLICK` command, which is generated by a control (wxMSW only).
- EVT_COMMAND_LEFT_DCLICK(id, func):
  Process a `wxEVT_COMMAND_LEFT_DCLICK` command, which is generated by a control (wxMSW only).
- EVT_COMMAND_RIGHT_CLICK(id, func):
  Process a `wxEVT_COMMAND_RIGHT_CLICK` command, which is generated by a control (wxMSW only).
- EVT_COMMAND_SET_FOCUS(id, func):
  Process a `wxEVT_COMMAND_SET_FOCUS` command, which is generated by a control (wxMSW only).
- EVT_COMMAND_KILL_FOCUS(id, func):
  Process a `wxEVT_COMMAND_KILL_FOCUS` command, which is generated by a control (wxMSW only).
- EVT_COMMAND_ENTER(id, func):
  Process a `wxEVT_COMMAND_ENTER` command, which is generated by a control.

##

Library: wxCore

Category: Events

## Public Member Functions
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor.
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection).
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection).
long | GetExtraLong () const
| Returns extra information dependant on the event objects type.
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox.
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection).
wxString | GetString () const
| Returns item string for a listbox or choice selection event.
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one.
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection.
void | SetClientData (void *clientData)
| Sets the client data for this event.
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event.
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member.
void | SetInt (int intCommand)
| Sets the m_commandInt member.
void | SetString (const wxString &string)
| Sets the m_commandString member.

List of all members.

## Constructor & Destructor Documentation

wxCommandEvent::wxCommandEvent | ( | wxEventType | commandEventType = `wxEVT_NULL`,
|  | int | id = `0` |
| ) |  |  |

Constructor.

## Member Function Documentation

void* wxCommandEvent::GetClientData | ( |  | ) | const

Returns client data pointer for a listbox or choice selection event (not valid for a deselection).

wxClientData* wxCommandEvent::GetClientObject | ( |  | ) | const

Returns client object pointer for a listbox or choice selection event (not valid for a deselection).

long wxCommandEvent::GetExtraLong | ( |  | ) | const

Returns extra information dependant on the event objects type.

If the event comes from a listbox selection, it is a boolean determining whether the event was a selection (true) or a deselection (false). A listbox deselection only occurs for multiple-selection boxes, and in this case the index and string values are indeterminate and the listbox must be examined by the application.

int wxCommandEvent::GetInt | ( |  | ) | const

Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox.

int wxCommandEvent::GetSelection | ( |  | ) | const

Returns item index for a listbox or choice selection event (not valid for a deselection).

Reimplemented in wxBookCtrlEvent.

wxString wxCommandEvent::GetString | ( |  | ) | const

Returns item string for a listbox or choice selection event.

If one or several items have been deselected, returns the index of the first deselected item. If some items have been selected and others deselected at the same time, it will return the index of the first selected item.

bool wxCommandEvent::IsChecked | ( |  | ) | const

This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one.

For the menu events, this method indicates if the menu item just has become checked or unchecked (and thus only makes sense for checkable menu items).

Notice that this method cannot be used with wxCheckListBox currently.

bool wxCommandEvent::IsSelection | ( |  | ) | const

For a listbox or similar event, returns true if it is a selection, false if it is a deselection.

If some items have been selected and others deselected at the same time, it will return true.

void wxCommandEvent::SetClientData | ( | void * | clientData | ) |

Sets the client data for this event.

void wxCommandEvent::SetClientObject | ( | wxClientData * | clientObject | ) |

Sets the client object for this event.

The client object is not owned by the event object and the event object will not delete the client object in its destructor.

The client object must be owned and deleted by another object (e.g. a control) that has longer life time than the event object.

void wxCommandEvent::SetExtraLong | ( | long | extraLong | ) |

Sets the m_extraLong member.

void wxCommandEvent::SetInt | ( | int | intCommand | ) |

Sets the m_commandInt member.

void wxCommandEvent::SetString | ( | const wxString & | string | ) |

Sets the m_commandString member.

|  | [ top ]